%% FUNCIÓN COEFICIENTES DOMINIO TEMPORAL FILTRO
%<coefDTFiltro>

%PARÁMETROS DE RETORNO:
%coeficientes: coeficientes de filtro seleccionado en el dominio temporal

%PARÁMETROS DE INGRESO:
%M: Número de subportadoras
%tipoFiltro: Referencia del tipo de filtro/ventana a usar


function coeficientes = coefDTFiltro(M,tipoFiltro)

 K=4;%Factor de solapamiento, requerido en filtro Phydyas

switch tipoFiltro
    
    case 'Phydyas'
        Hk=[1 0.97196 sqrt(2)/2 0.235147];%Coeficientes laterales filtro PHYDYAS
        hn=zeros(1,K*M-1);
        
        for n=1:K*M-1%límite de coeficientes del filtro
            hIter=0;
            for k=1:K-1
                hIter=hIter+2*((-1)^(k))*Hk(k+1)*cos(2*pi*k*n/(K*M));
            end
            hn(n)=Hk(1)+hIter;
        end
        coeficientes=hn/max(hn);%Normalizado a la unidad
%       length(coeficientes);
        %sprintf('Longitud filtro Phydyas, L=  %d',length(coeficientes))
        
    case 'Rectangular'
        coeficientes=ones(1,M); %No requiere normalización
        %sprintf('Longitud filtro/ventana rectangular, L=  %d',length(coeficientes))
end

end

